//+------------------------------------------------------------------+
//|                                                       CS2000.mq4 |
//|                            Copyright  2009, David KheongHo Lai. |
//|                                   http://davidke20.blogspot.com/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, David KheongHo Lai"
#property link      "davidke20.blogspot.com"

extern double TakeProfit   = 10;
extern double StopLoss     = 200;
extern double Lots         = 0.1;
extern int    MaxTrades    = 1;
extern int    MovingAverage= 2000;
extern int    MA_Type      = 1;
extern int    MagicNumber  = 772188;

datetime TimeStamp=0;

int init()
{
   if(Digits==3 || Digits==5)
   StopLoss=StopLoss*10;
   TakeProfit=TakeProfit*10;
return(0);
}
int deinit(){return(0);}


int TotalOrders(int OrdersMagic)
{
   int Total=0;
   for(int cnt=0;cnt<OrdersTotal();cnt++)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber()==OrdersMagic)
      Total++;
   }
   return(Total);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
{
   int cnt, ticket;
   double sl,tp;

   if(Bars<2000)
   {
      Comment("History data less than 2000, kindly download from history centre and restart EA");
      return(0);  
   }

   double MA=iMA(NULL,0,MovingAverage,0,MA_Type,PRICE_CLOSE,0);

   if(TotalOrders(MagicNumber)<MaxTrades && TimeStamp!=iTime(NULL,0,0))
   {
      if(AccountFreeMargin()<(1000*Lots))
        {
         Comment("No money. Kindly top up account or change to a smaller lot size. Account free margin = ", AccountFreeMargin());
         return(0);  
        }
      // check for long position (BUY) possibility
      if(Ask>MA && Close[1]<MA)
      {
         if(TakeProfit>10)tp=Ask+TakeProfit*Point;
         else tp=0;
         if(StopLoss>10)sl=Bid-StopLoss*Point;
         else sl=0;
         if(OrderSend(Symbol(),OP_BUY,Lots,Ask,3,sl,tp,"CycleSurfer",MagicNumber,0,DodgerBlue)==-1)
         Print("Error opening BUY order : ",GetLastError()); 
         else
         TimeStamp=iTime(NULL,0,0);
      }
      // check for short position (SELL) possibility
      if(Bid<MA && Close[1]>MA)
      {
         if(TakeProfit>10)tp=Bid-TakeProfit*Point;
         else tp=0;
         if(StopLoss>10)sl=Ask+StopLoss*Point;
         else sl=0;
         if(OrderSend(Symbol(),OP_SELL,Lots,Bid,3,sl,tp,"CycleSurfer",MagicNumber,0,FireBrick)==-1)
         Print("Error opening SELL order : ",GetLastError()); 
         else
         TimeStamp=iTime(NULL,0,0);
      }
   }
   return(0);
}